## gtirb-7d8d02eecdeb199b91aefce7f0296b38bc9314a8.tar.gz

=== CMakeLists.txt ===
#
# Cmake Configuration
#

# Need 3.10 to support CXX_STANDARD=17 and protobuf::protoc
cmake_minimum_required(VERSION 3.10.0)

# The version.txt file is the official record of the version number. We use the
# contents of that file to set the project version for use in other CMake files.
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/version.txt" ver)

string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
set(GTIRB_MAJOR_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
set(GTIRB_MINOR_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
set(GTIRB_PATCH_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_PROTOBUF ([0-9]*)" _ ${ver})
set(GTIRB_PROTOBUF_VERSION ${CMAKE_MATCH_1})

cmake_policy(SET CMP0048 NEW)
project(
  GTIRB
  VERSION "${GTIRB_MAJOR_VERSION}.${GTIRB_MINOR_VERSION}.${GTIRB_PATCH_VERSION}"
)
set(PACKAGE_BRANCH master)

include(CheckFunctionExists)
include(CheckCXXSourceCompiles)
include(CheckIncludeFile)
include(Macros.cmake)
include(AlignOf.cmake)
include(CMakePackageConfigHelpers)

option(ENABLE_CONAN "Use Conan to inject dependencies" OFF)

if(ENABLE_CONAN)
  set(CONAN_SYSTEM_INCLUDES ON)
  include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup()
endif()

# ---------------------------------------------------------------------------
# Build options
# ---------------------------------------------------------------------------

set(GTIRB_MSVC_PARALLEL_COMPILE_JOBS
    "0"
    CACHE
      STRING
      "Number of parallel compiler jobs used for Visual Studio compiles. 0 means use all processors. Default is 0."
)

option(GTIRB_ENABLE_TESTS "Enable building and running unit tests." ON)
option(GTIRB_ENABLE_MYPY "Enable checking python types with mypy." ON)

# This just sets the builtin BUILD_SHARED_LIBS, but if defaults to ON instead of
# OFF.
option(GTIRB_BUILD_SHARED_LIBS "Build shared libraries." ON)
if(GTIRB_BUILD_SHARED_LIBS)
  set(BUILD_SHARED_LIBS ON)
else()
  set(BUILD_SHARED_LIBS OFF)
endif()
if(UNIX AND NOT BUILD_SHARED_LIBS)
  # Find only static libraries
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  add_compile_options(-static)
endif()

enable_testing()

# Set ENABEL_CODE_COVERAGE to default off, unless you want to test c++ coverage
option(ENABLE_CODE_COVERAGE
       "Build with instrumentation for collecting code coverage" OFF
)

if(ENABLE_CODE_COVERAGE)
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL GNU OR ${CMAKE_CXX_COMPILER_ID} STREQUAL
                                              Clang
  )
    add_compile_options(--coverage)
    link_libraries(--coverage)
  else()
    message(FATAL_ERROR "no support for code coverage on this target")
  endif()
endif()

# Whether or not to run clang-tidy (if present)
option(GTIRB_RUN_CLANG_TIDY "Enable running of clang-tidy." ON)

# Define the cache variables for the API options.
option(GTIRB_CXX_API "Whether or not the C++ API is built." ON)
option(GTIRB_PY_API "Whether or not the Python API is built." ON)
option(GTIRB_CL_API "Whether or not the Common Lisp API is built." ON)
option(GTIRB_JAVA_API "Whether or not the Java API is built." ON)

# Determine whether or not to strip debug symbols and set the build-id. This is
# only really needed when we are building ubuntu *-dbg packages
option(GTIRB_STRIP_DEBUG_SYMBOLS
       "Whether or not to strip debug symbols and set the build-id." OFF
)

option(
  GTIRB_RELEASE_VERSION
  "Whether or not to build package versions without dev/SNAPSHOT suffixes.  Applies to the python and java APIs."
  OFF
)

# Determine whether or not the APIs are REALLY built or not.
# === C++ ===
set(CXX_API ${GTIRB_CXX_API})

# === Python ===
set(PY_API ${GTIRB_PY_API})
if(GTIRB_PY_API)
  gtirb_find_python()

  if(PYTHON)
    set(PYTHON_MINIMUM_VERSION "3.6")
    if("${Python3_VERSION}" VERSION_LESS "${PYTHON_MINIMUM_VERSION}")
      message(
        WARNING
          "${PYTHON} --version is ${Python3_VERSION}, which is less than the minimum required, ${PYTHON_MINIMUM_VERSION}; disabling building of API."
      )
      set(PY_API OFF)
    endif()
  else()
    message(
      WARNING
        "Python interpreter not found; disabling building of Python API.
If this is in error, try giving -DPYTHON=... to CMake to specify what program to use."
    )
    set(PY_API OFF)
  endif()
endif()

# === Common Lisp ===
# TODO: test the CL API on other CL interpreters and search for those in
# addition to SBCL when looking for a default CL interpeter
set(CL_API ${GTIRB_CL_API})
if(GTIRB_CL_API)
  find_program(LISP "sbcl")
  set(QUICKLISP
      "$ENV{HOME}/quicklisp"
      CACHE STRING "The Quicklisp installation to use."
  )
  set(LISP_MINIMUM_VERSION "1.4.5")

  if(NOT LISP)
    message(
      WARNING
        "Lisp interpreter not found; disabling building of Lisp API.
If this is in error, try giving -DLISP=... to CMake to specify what program to use."
    )
    set(CL_API OFF)
  elseif(NOT EXISTS "${QUICKLISP}")
    message(
      WARNING
        "Quicklisp installation not found; disabling building of Lisp API.
If this is in error, try giving -DQUICKLISP=... to CMake to specify what directory to use."
    )
    set(CL_API OFF)
  else()
    execute_process(COMMAND "${LISP}" "--version" OUTPUT_VARIABLE LISP_VERSION)
    string(REPLACE "SBCL" "" LISP_VERSION "${LISP_VERSION}")
    string(REPLACE ".debian" "" LISP_VERSION "${LISP_VERSION}")

    if("${LISP_VERSION}" VERSION_LESS "${LISP_VERSION}")
      message(
        WARNING
          "${LISP} --version is ${LISP_VERSION}, which is less then the minimum required, ${LISP_MINIMUM_VERSION}; disabling building of API."
      )
      set(CL_API OFF)
    endif()
  endif()
endif()

# === Java ===
set(JAVA_API ${GTIRB_JAVA_API})
if(GTIRB_JAVA_API)
  find_package(Java 1.8.0 COMPONENTS Development)
  if(NOT JAVA_FOUND)
    message(WARNING "Java 8 compiler not found; disabling building of Java API.
If this is in error, try setting the environment variable $JAVA_HOME."
    )
    set(JAVA_API OFF)
  else()
    find_program(MVN mvn)
    if(NOT MVN)
      message(
        WARNING
          "Maven not found; disabling building of Java API. If this is in "
          "error, try setting -DMVN=<path-to-maven> on the CMake command-line"
      )
      set(JAVA_API OFF)
    endif()
  endif()
endif()

# Documentation options.
option(GTIRB_DOCUMENTATION "Whether or not documentation is built." ON)

# ---------------------------------------------------------------------------
# Global settings
# ---------------------------------------------------------------------------

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src)
if(WIN32)
  set(CMAKE_DEBUG_POSTFIX
      "d"
      CACHE STRING "add a postfix, usually d on windows"
  )
endif()
set(CMAKE_RELEASE_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows"
)
set(CMAKE_RELWITHDEBINFO_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows"
)
set(CMAKE_MINSIZEREL_POSTFIX
    ""
    CACHE STRING "add a postfix, usually empty on windows"
)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

if(CXX_API)
  # Use C++17
  set(CMAKE_CXX_STANDARD 17)
  # Error if it's not available
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  # Specifically check for gcc-7 or later. gcc-5 is installed on many systems
  # and will accept -std=c++17, but does not fully support the standard.
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "7.0.0")
      message(FATAL_ERROR "gcc 7 or later is required to build gtirb")
    endif()
  endif()

  set(CMAKE_CXX_VISIBILITY_PRESET hidden)

  #
  # Global Options (Compile / Link)
  #
  add_compile_options(-DBOOST_MULTI_INDEX_DISABLE_SERIALIZATION)

  # MSVC-specific Options
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
    if(NOT GTIRB_MSVC_PARALLEL_COMPILE_JOBS STREQUAL "1")
      if(GTIRB_MSVC_PARALLEL_COMPILE_JOBS STREQUAL "0")
        add_compile_options(-MP)
        message(STATUS "Parallel compilation enabled")
      else()
        add_compile_options(-MP${GTIRB_MSVC_PARALLEL_COMPILE_JOBS})
        message(
          STATUS
            "Parallel compilation with ${GTIRB_MSVC_PARALLEL_COMPILE_JOBS} jobs"
        )
      endif()
    else()
      message(STATUS "Parallel compilation disabled")
    endif()

    add_compile_options(-D_CRT_SECURE_NO_WARNINGS)
    add_compile_options(-D_MBCS)
    add_compile_options(-D_SCL_SECURE_NO_WARNINGS)
    # We need to add both so that there is not a mismatch between Win32 SDK
    # headers (which use UNICODE) and C Standard Library headers (which use
    # _UNICODE).
    add_compile_options(-D_UNICODE)
    add_compile_options(-DUNICODE)
    add_compile_options(-D_WIN32)
    # Disable macro definitions for min and max that conflict with the STL.
    add_compile_options(-DNOMINMAX)
    # Enable RTTI. FIXME: stop using typeid so we can disable this and add -fno-
    # rtti to the Clang/GCC compiler options.
    add_compile_options(-GR)
    # Enable exceptions, which are basically required because of our reliance on
    # boost.
    add_compile_options(-EHsc)
    # Enabled a sensible warning level and treat all warnings as errors.
    add_compile_options(-W4)
    add_compile_options(-WX)

    # Enable bigobj support, otherwise IR.cpp and Module.cpp will refuse to
    # compile due to execeeding the number of sections allowed in an object
    # file. FIXME: we should not have that many template instantiations.
    add_compile_options(-bigobj)

    add_compile_options(-sdl) # Enable extra security checks
    add_compile_options(-permissive-) # Disable permissive mode

    add_compile_options(-wd4996) # VC8: Deprecated libc functions.
    # This is a warning about a change in behavior from old versions of visual
    # c++.  We want the new (standard-compliant) behavior, so we don't want the
    # warning.  The warning is that using an array in a class initializer list
    # will cause its elements to be default initialized.
    add_compile_options(-wd4351)
    add_compile_options(-wd4146) # unary minus operator applied to unsigned
                                 # type, result still unsigned

    # C4505: 'google::protobuf::internal::MapField<...>::ContainsMapKey':
    # unreferenced local function has been removed
    add_compile_options(-wd4505)

    # C4267: protobuf-generated headers, at least w/ protobuf 3.9.1, trigger
    # MSVC's "conversion from 'size_t' to 'int', possible loss of data" warning.
    add_compile_options(-wd4267)

    # Release target options
    add_compile_options($<$<CONFIG:Release>:-GL>) # Enable whole program
                                                  # optimization
    add_link_options($<$<CONFIG:Release>:-ltcg>) # Enable link-time code
                                                 # generation
  elseif((${CMAKE_CXX_COMPILER_ID} STREQUAL GNU) OR (${CMAKE_CXX_COMPILER_ID}
                                                     STREQUAL Clang)
  )
    add_compile_options(-Wall -Wextra -Wpointer-arith -Wshadow -Werror)
    add_compile_options(-fPIC)
  endif()
endif()

# ---------------------------------------------------------------------------
# Boost
# ---------------------------------------------------------------------------
if(CXX_API)
  find_package(Boost 1.68 REQUIRED)

  add_compile_options(-DBOOST_CONFIG_SUPPRESS_OUTDATED_MESSAGE)
  add_compile_options(-DBOOST_SYSTEM_NO_DEPRECATED)

  # Boost versions 1.70.0+ may use Boost's provided CMake support rather than
  # CMake's internal Boost support. The former uses "Boost::boost" and so on,
  # while the latter uses "Boost_BOOST" and so on. This normalizes the two cases
  # to use Boost_INCLUDE_DIRS and Boost_LIBRARIES.
  if(TARGET Boost::headers)
    get_target_property(
      Boost_INCLUDE_DIRS Boost::headers INTERFACE_INCLUDE_DIRECTORIES
    )
  endif()

=== cl/CMakeLists.txt ===
file(GLOB CL_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.lisp
     ${CMAKE_CURRENT_SOURCE_DIR}/*.asd
)

set(CL_EXECUTABLE_STEMS dot update)

foreach(CL_EXECUTABLE_STEM ${CL_EXECUTABLE_STEMS})
  set(CL_EXECUTABLE ${CMAKE_CURRENT_BINARY_DIR}/gtirb-${CL_EXECUTABLE_STEM})
  list(APPEND CL_EXECUTABLES ${CL_EXECUTABLE})

  add_custom_command(
    OUTPUT ${CL_EXECUTABLE}
    DEPENDS ${CL_SOURCES} ${PROTO_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND
      ${LISP} --noinform --dynamic-space-size 16384 --no-userinit --no-sysinit
      --disable-debugger --load ${QUICKLISP}/setup.lisp --eval
      "(asdf:initialize-source-registry `(:source-registry (:tree \"${CMAKE_CURRENT_SOURCE_DIR}\") :inherit-configuration))"
      --eval "(ql:quickload :gtirb/${CL_EXECUTABLE_STEM})" --eval
      "(setf uiop/image::*lisp-interaction* nil)" --eval
      "(asdf:make :gtirb/run-${CL_EXECUTABLE_STEM} :type :program :monolithic t)"
      --eval "(uiop/image:quit)"
    COMMAND ${CMAKE_COMMAND} -E copy gtirb-${CL_EXECUTABLE_STEM}
            ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E remove gtirb-${CL_EXECUTABLE_STEM}
    VERBATIM
  )
endforeach(CL_EXECUTABLE_STEM)

add_custom_target(clgtirb ALL DEPENDS ${CL_EXECUTABLES})

if(GTIRB_ENABLE_TESTS)
  add_test(
    NAME testgtirbcl
    COMMAND
      ${LISP} --noinform --dynamic-space-size 16384 --no-userinit --no-sysinit
      --disable-debugger --load "${QUICKLISP}/setup.lisp" --eval
      "(asdf:initialize-source-registry `(:source-registry (:tree \"${CMAKE_CURRENT_SOURCE_DIR}\") :inherit-configuration))"
      --eval "(ql:quickload :gtirb/test)" --eval "(gtirb/test:batch-test)"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
  )
endif()

=== doc/CMakeLists.txt ===
add_custom_target(doc)
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html")

if(CXX_API)
  set(CPP_TAGFILE "${CMAKE_CURRENT_BINARY_DIR}/CPP_DOXY.tag")
  set(CPP_TAGFILE_RULE "${CPP_TAGFILE}=cpp")
  set(CPP_DOX_ENABLED "CPP_ONLY")
  set(CPP_API_VISIBLE "yes")
  add_subdirectory(cpp)
else()
  set(CPP_TAGFILE_RULE "")
  set(CPP_DOX_ENABLED "")
  set(CPP_API_VISIBLE "no")
endif()

if(PY_API)
  add_subdirectory(python)
  set(PY_DOX_ENABLED "PY_ONLY")
  set(PY_API_VISIBLE "yes")
else()
  set(PY_DOX_ENABLED "")
  set(PY_API_VISIBLE "no")
endif()

if(CL_API)
  add_subdirectory(cl)
  set(CL_DOX_ENABLED "CL_ONLY")
  set(CL_API_VISIBLE "yes")
else()
  set(CL_DOX_ENABLED "")
  set(CL_API_VISIBLE "no")
endif()

if(JAVA_API)
  add_subdirectory(java)
  set(JAVA_DOX_ENABLED "JAVA_ONLY")
  set(JAVA_API_VISIBLE "yes")
else()
  set(JAVA_DOX_ENABLED "")
  set(JAVA_API_VISIBLE "no")
endif()

add_subdirectory(examples)
add_subdirectory(general)

=== java/CMakeLists.txt ===
#
# Cmake configuration for java build
#

# ---------------------------------------------------------------------------
# Get upper bound of compatible versions
# ---------------------------------------------------------------------------

if("${Protobuf_VERSION}" VERSION_LESS 3.21.7)
  # Before 3.21.7, generated code is incompatible with the 4.* API.
  set(GTIRB_PROTOBUF_UPPER_BOUND "4.0.0-rc-1")
else()
  # Upper bound for 3.21.7 and above is not yet known.
  set(GTIRB_PROTOBUF_UPPER_BOUND "")
endif()

# ---------------------------------------------------------------------------
# Building the gtirb protobuf files into java
# ---------------------------------------------------------------------------
set(GTIRB_JAVA_SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/src)

# Directory containing the *.class files generated from the *.proto files
set(GTIRB_PROTO_CLASS_DIR "${GTIRB_JAVA_SOURCE_DIR}/com/grammatech/gtirb/proto")

# Add commands to compile the *.proto files to *.class files
foreach(GTIRB_PROTO_FILE ${GTIRB_PROTO_FILES})
  get_filename_component(GTIRB_PROTO_BASENAME ${GTIRB_PROTO_FILE} NAME_WE)
  set(GTIRB_PROTO_CLASS_FILE
      ${GTIRB_PROTO_CLASS_DIR}/${GTIRB_PROTO_BASENAME}OuterClass.java
  )
  add_custom_command(
    OUTPUT ${GTIRB_PROTO_CLASS_FILE}
    COMMAND ${Protobuf_PROTOC_EXECUTABLE} --java_out=${GTIRB_JAVA_SOURCE_DIR}
            --proto_path=${GTIRB_PROTO_DIR} ${GTIRB_PROTO_FILE}
  )
  list(APPEND GTIRB_PROTOBUF_JAVA ${GTIRB_PROTO_CLASS_FILE})
endforeach()

# ---------------------------------------------------------------------------
# Building the gtirb java API
# ---------------------------------------------------------------------------
if(GTIRB_RELEASE_VERSION)
  set(GTIRB_JAVA_SNAPSHOT_SUFFIX "")
else()
  set(GTIRB_JAVA_SNAPSHOT_SUFFIX "-SNAPSHOT")
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/pom.xml.in ${CMAKE_CURRENT_BINARY_DIR}/pom.xml
  @ONLY
)

set(GTIRB_API_JAVAS
    auxdatacodec/BoolCodec
    auxdatacodec/ByteCodec
    auxdatacodec/Codec
    auxdatacodec/FloatCodec
    auxdatacodec/IntegerCodec
    auxdatacodec/ListCodec
    auxdatacodec/LongCodec
    auxdatacodec/MapCodec
    auxdatacodec/OffsetCodec
    auxdatacodec/SetCodec
    auxdatacodec/ShortCodec
    auxdatacodec/StringCodec
    auxdatacodec/Tuple1Codec
    auxdatacodec/Tuple2Codec
    auxdatacodec/Tuple3Codec
    auxdatacodec/Tuple4Codec
    auxdatacodec/Tuple5Codec
    auxdatacodec/UuidCodec
    auxdatacodec/Variant2Codec
    auxdatacodec/Variant3Codec
    auxdatacodec/Variant11Codec
    tuple/Tuple1
    tuple/Tuple2
    tuple/Tuple3
    tuple/Tuple4
    tuple/Tuple5
    variant/Token
    variant/Variant2
    variant/Variant3
    variant/Variant11
    AuxDataContainer
    AuxDataSchema
    AuxDataSchemas
    ByteBlock
    ByteInterval
    CFG
    CfiDirective
    CodeBlock
    DataBlock
    Edge
    SectionPropertyTuple
    ElfSymbolInfoTuple
    ElfSymbolVersionsTable
    IR
    Module
    Node
    Offset
    PeExportEntry
    PeImportEntry
    PeResourceEntry
    ProbFuncName
    ProxyBlock
    Section
    SymAddrAddr
    SymAddrConst
    SymbolicExpression
    Symbol
    TreeListItem
    TreeListUtils
    TypeTableEntry
    Util
)

foreach(GTIRB_API_JAVA ${GTIRB_API_JAVAS})
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/com/grammatech/gtirb/${GTIRB_API_JAVA}.java
    ${GTIRB_JAVA_SOURCE_DIR}/com/grammatech/gtirb/${GTIRB_API_JAVA}.java
    COPYONLY
  )
endforeach()

# ---------------------------------------------------------------------------
# Creating a version file to report version information
# ---------------------------------------------------------------------------
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Version.java.in
  ${GTIRB_JAVA_SOURCE_DIR}/com/grammatech/gtirb/Version.java @ONLY
)

# Append generated Version.java
list(APPEND GTIRB_API_JAVAS Version)

foreach(GTIRB_API_JAVA ${GTIRB_API_JAVAS})
  list(
    APPEND GTIRB_API_SOURCES
           ${GTIRB_JAVA_SOURCE_DIR}/com/grammatech/gtirb/${GTIRB_API_JAVA}.java
  )
endforeach()

set(GTIRB_JAVA_API_VERSION
    "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
)
set(TARGET_DIR "${CMAKE_CURRENT_BINARY_DIR}/target")
set(GTIRB_JAVA_APIDOCS_DIR
    "${TARGET_DIR}/apidocs"
    PARENT_SCOPE
)

set(GTIRB_JAVA_API_JARS
    "${TARGET_DIR}/gtirb_api-${GTIRB_JAVA_API_VERSION}.jar"
    "${TARGET_DIR}/gtirb_api-${GTIRB_JAVA_API_VERSION}-sources.jar"
    "${TARGET_DIR}/gtirb_api-${GTIRB_JAVA_API_VERSION}-javadoc.jar"
)

if(NOT GTIRB_DOCUMENTATION)
  set(MAVEN_PACKAGE_ARGS "-Dmaven.javadoc.skip=true")
endif()

add_custom_command(
  OUTPUT ${GTIRB_JAVA_API_JARS} ${GTIRB_JAVA_APIDOCS_DIR}/index.html
  COMMAND ${MVN} package ${MAVEN_PACKAGE_ARGS}
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  DEPENDS ${GTIRB_API_SOURCES} ${GTIRB_PROTOBUF_JAVA}
)

add_custom_target(gtirb-java-api ALL DEPENDS ${GTIRB_JAVA_API_JARS})

# ---------------------------------------------------------------------------
# Building the test code
# ---------------------------------------------------------------------------

if(GTIRB_ENABLE_TESTS)
  if(WIN32)
    set(DIR_SEP "\;")
  else()
    set(DIR_SEP ":")
  endif()

  execute_process(
    COMMAND ${MVN} -q exec:exec -Dexec.classpathScope=compile
            -Dexec.executable=echo -Dexec.args=%classpath
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    OUTPUT_VARIABLE JAR_FILE_LIST
  )
  string(STRIP ${JAR_FILE_LIST} JAR_FILE_LIST)

  file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tests/
       DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tests
  )

  set(GTIRB_JAVA_TESTS
      TestAuxData
      TestByteIntervals
      TestIrSanity
      TestSymbolicExpressions
      TestModules
      TestSections
      TestSymbols
      TestTuple
      TestVariant
  )

  foreach(GTIRB_JAVA_TEST ${GTIRB_JAVA_TESTS})
    add_custom_command(
      TARGET gtirb-java-api
      POST_BUILD
      COMMAND
        ${Java_JAVAC_EXECUTABLE} -cp ${JAR_FILE_LIST}:${JUNIT_STANDALONE_JAR} -d
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}/tests/${GTIRB_JAVA_TEST}.java
      COMMENT "Building ${GTIRB_JAVA_TEST}" DEPENDS
              ${CMAKE_CURRENT_BINARY_DIR}/tests/${GTIRB_JAVA_TEST}.java
    )
  endforeach()

  add_test(
    NAME JUnitTests
    COMMAND
      ${Java_JAVA_EXECUTABLE} -ea -jar ${JUNIT_STANDALONE_JAR} execute
      --class-path ${CMAKE_CURRENT_BINARY_DIR}:${JAR_FILE_LIST}
      --scan-class-path
  )

endif()

=== proto/CMakeLists.txt ===
# GTIRB_PROTO_DIR
#
# Directory containing the default *.proto files.

set(GTIRB_PROTO_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}
    PARENT_SCOPE
)

# GTIRB_PROTO_FILES
#
# List of *.proto definition files.

file(GLOB GTIRB_PROTO_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.proto)
set(GTIRB_PROTO_FILES
    ${GTIRB_PROTO_FILES}
    PARENT_SCOPE
)

=== python/CMakeLists.txt ===
if(GTIRB_ENABLE_MYPY)
  find_program(MYPY mypy)
  find_program(MYPY_PROTOBUF protoc-gen-mypy)
  if(MYPY AND MYPY_PROTOBUF)
    set(ENABLE_MYPY ON)
    set(MYPY_PROTOBUF_FLAGS --mypy_out=${CMAKE_CURRENT_BINARY_DIR})
    configure_file(mypy.ini.in mypy.ini @ONLY)
  else()
    set(ENABLE_MYPY OFF)
    if(NOT MYPY)
      message(
        WARNING "mypy not found. Type checking with mypy will be disabled."
      )
    endif()
    if(NOT MYPY_PROTOBUF)
      message(
        WARNING
          "protoc-gen-mypy not found. Type checking with mypy will be disabled."
      )
    endif()
  endif()
endif()

# Create a PEP 561 py.typed to let clients find the inline type annotations.
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/gtirb/py.typed "")

if("${Protobuf_VERSION}" VERSION_LESS "3.19.0")
  # Older protobuf compilers generate code incompatible with newer runtimes.
  set(GTIRB_PROTOBUF_CONSTRAINT "protobuf >= ${Protobuf_VERSION}, < 4.0")
else()
  set(GTIRB_PROTOBUF_CONSTRAINT "protobuf >= 4.0")
endif()

configure_file(pyproject.toml.in pyproject.toml @ONLY)
configure_file(README.md README COPYONLY)
configure_file(requirements-dev.txt requirements-dev.txt COPYONLY)
configure_file(requirements-mypy.txt requirements-mypy.txt COPYONLY)
configure_file(tox.ini tox.ini COPYONLY)
# Copy the license from the top-level of the source repo.
configure_file(${CMAKE_SOURCE_DIR}/LICENSE.txt LICENSE COPYONLY)

# ---------------------------------------------------------------------------
# Building the gtirb protobuf files into python
# ---------------------------------------------------------------------------

set(PROTO_PY_DIR ${CMAKE_CURRENT_BINARY_DIR}/gtirb/proto)

# Rewrite the proto definitions to use paths when including other definitions.
# We do this instead of using the one-line configure_file() command so that the
# proto/*.proto files in the source directory do not need to be rewritten for
# the CL API.

foreach(GTIRB_PROTO_FILE ${GTIRB_PROTO_FILES})
  get_filename_component(PROTO_BASE ${GTIRB_PROTO_FILE} NAME_WE)
  set(PROTO_PY_OUT "${PROTO_PY_DIR}/${PROTO_BASE}.proto")
  file(READ ${GTIRB_PROTO_FILE} PROTO_DEF_STR)
  string(REGEX REPLACE "import \"" "import \"gtirb/proto/" PROTO_DEF_STR
                       "${PROTO_DEF_STR}"
  )
  file(WRITE ${PROTO_PY_OUT} "${PROTO_DEF_STR}")

  set(PROTO_PY_SOURCE "${PROTO_PY_DIR}/${PROTO_BASE}_pb2.py")
  add_custom_command(
    OUTPUT "${PROTO_PY_SOURCE}"
    COMMAND
      protobuf::protoc --python_out ${CMAKE_CURRENT_BINARY_DIR}
      ${MYPY_PROTOBUF_FLAGS} -I "${CMAKE_CURRENT_BINARY_DIR}" ${PROTO_PY_OUT}
    DEPENDS ${PROTO_PY_OUT} protobuf::protoc
    VERBATIM
  )
  list(APPEND PROTO_PY_SOURCES "${PROTO_PY_SOURCE}")
endforeach()
add_custom_target(py-proto DEPENDS ${PROTO_PY_SOURCES})

# existing Python files
file(GLOB PY_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/gtirb/*.py
     ${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py
)

add_custom_target(pygtirb ALL DEPENDS ${PY_SOURCES} py-proto)
add_custom_command(
  TARGET pygtirb
  COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/gtirb"
          "${CMAKE_CURRENT_BINARY_DIR}/tests"
  COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/gtirb"
          "${CMAKE_CURRENT_BINARY_DIR}/gtirb"
  COMMAND ${CMAKE_COMMAND} -E copy_directory
          "${CMAKE_CURRENT_SOURCE_DIR}/tests"
          "${CMAKE_CURRENT_BINARY_DIR}/tests"
)

if(GTIRB_RELEASE_VERSION)
  set(GTIRB_PYTHON_DEV_SUFFIX "")
else()
  set(GTIRB_PYTHON_DEV_SUFFIX ".dev")
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/version.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/gtirb/version.py @ONLY
)

if(GTIRB_ENABLE_TESTS)
  find_program(TOX tox)
  if(TOX)
    if(ENABLE_MYPY)
      # Only run mypy if we actually generated stubs for the protobuf
      # definitions.
      add_test(
        NAME mypy
        COMMAND tox run -e mypy
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/"
      )
    endif()

    if(ENABLE_CODE_COVERAGE)
      set(GTIRB_TOX_FLAGS)
    else()
      set(GTIRB_TOX_FLAGS "--")
    endif()
    execute_process(
      COMMAND ${TOX} -l
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      OUTPUT_VARIABLE TOX_ENVIRONMENTS
    )
    string(REGEX MATCHALL "py3[0-9a-z-]*" TOX_ENVIRONMENTS ${TOX_ENVIRONMENTS})
    foreach(TOX_ENVIRONMENT ${TOX_ENVIRONMENTS})
      add_test(
        NAME ${TOX_ENVIRONMENT}
        COMMAND ${TOX} run -e ${TOX_ENVIRONMENT} ${GTIRB_TOX_FLAGS}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      )
    endforeach()
  else()
    message(SEND_ERROR "Python tests require tox to be installed")
  endif()
endif()

# Convenience targets for installing python
add_custom_target(
  python-wheel
  DEPENDS pygtirb
  COMMAND "${PYTHON}" -m pip wheel --no-deps "${CMAKE_CURRENT_BINARY_DIR}"
)

=== src/CMakeLists.txt ===
set(PROJECT_NAME gtirb)

add_subdirectory(gtirb/proto)

if(GTIRB_RUN_CLANG_TIDY)
  find_program(
    CLANG_TIDY_EXE
    NAMES "clang-tidy"
    DOC "Path to clang-tidy executable"
  )
  if(NOT CLANG_TIDY_EXE)
    message(STATUS "clang-tidy not found.")
  else()
    message(STATUS "clang-tidy found: ${CLANG_TIDY_EXE}")
  endif()
else()
  message(STATUS "clang-tidy disabled.")
endif()

if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
  # add_compile_options(-wd4251)  # Non-exportable template classes.
  add_compile_options(-DBOOST_UUID_RANDOM_PROVIDER_FORCE_WINCRYPT)
elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL GNU)
  # add_compile_options(-Wno-unused-function)
  add_compile_options(-mtune=generic)
  add_compile_options(-pthread)
elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
  # add_compile_options(-Wno-unused-function)
  add_compile_options(-mtune=generic)
  add_compile_options(-pthread)
endif()

# generate version.h from version.h.in
configure_file(
  "${CMAKE_SOURCE_DIR}/include/gtirb/version.h.in"
  "${CMAKE_BINARY_DIR}/include/gtirb/version.h" @ONLY
)

# specify header files that need to be installed
set(${PROJECT_NAME}_H
    "${CMAKE_SOURCE_DIR}/include/gtirb/Addr.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Allocator.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/AuxData.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/AuxDataContainer.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/AuxDataSchema.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/ByteInterval.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/CFG.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Casting.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/CfgNode.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/CodeBlock.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Context.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/DataBlock.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/DecodeMode.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/ErrorOr.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Export.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/IR.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Module.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Node.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Observer.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Offset.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/ProxyBlock.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Section.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Symbol.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/SymbolicExpression.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/Utility.hpp"
    "${CMAKE_SOURCE_DIR}/include/gtirb/gtirb.hpp"
)

# specify source files
set(${PROJECT_NAME}_SRC
    AuxData.cpp
    AuxDataContainer.cpp
    ByteInterval.cpp
    CodeBlock.cpp
    Context.cpp
    CFG.cpp
    DataBlock.cpp
    ErrorOr.cpp
    IR.cpp
    Module.cpp
    Node.cpp
    Offset.cpp
    ProxyBlock.cpp
    Section.cpp
    Serialization.cpp
    Symbol.cpp
    SymbolicExpression.cpp
    Utility.cpp
)

file(GLOB ProtoFiles "${CMAKE_CURRENT_SOURCE_DIR}/gtirb/proto/*.proto")
set(${PROJECT_NAME}_PROTO ${ProtoFiles})
source_group("proto" FILES ${ProtoFiles})

if(UNIX AND NOT WIN32)
  set(SYSLIBS ${CMAKE_DL_LIBS})
else()
  set(SYSLIBS)
endif()

gtirb_add_library()
# FIXME We should be setting SOVERSION with an ABI version number once the ABI
# stabilizes. For now, since most patches affect the ABI anyway, we just use the
# GTIRB_VERSION as the SOVERSION.
set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${GTIRB_VERSION})
if(WIN32)
  # FIXME: We need to figure out how to handle cutting a release build. For the
  # moment, treat everything as a pre-release build.
  set(GTIRB_IS_PRERELEASE 1)
  configure_file(
    ${CMAKE_SOURCE_DIR}/resources/windows_version_resource.rc.in
    ${CMAKE_BINARY_DIR}/version.rc @ONLY
  )
  target_sources(${PROJECT_NAME} PRIVATE ${CMAKE_BINARY_DIR}/version.rc)
  source_group(Resources FILES ${CMAKE_BINARY_DIR}/version.rc)
endif()

# Find our headers
target_include_directories(
  ${PROJECT_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
)
target_include_directories(
  ${PROJECT_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>
)
target_include_directories(
  ${PROJECT_NAME} PRIVATE $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include/gtirb>
)
target_include_directories(
  ${PROJECT_NAME} PRIVATE $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/src/>
)

# NOTE (2020-12): tried using protobuf::libprotobuf to get relocatable exports,
# but it is apparently treated inconsistently between static and shared builds.
# For simplicity, we revert to using ${Protobuf_LIBRARIES} for now.

target_link_libraries(
  ${PROJECT_NAME}
  PUBLIC ${SYSLIBS}
         ${Boost_LIBRARIES}
         ${Protobuf_LIBRARIES}
         # Link in this static lib, but don't make it a transitive dependency of
         # TestGTIRB, etc
  PRIVATE gtirb_proto
)
target_compile_definitions(
  ${PROJECT_NAME} PRIVATE GTIRB_${PROJECT_NAME}_EXPORTS
  GTIRB_WRAP_UTILS_IN_NAMESPACE
)
target_include_directories(${PROJECT_NAME} PUBLIC "${PROTOBUF_INCLUDE_DIRS}")

if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
  # These four warnings come from protobuf headers, disabling them this way
  # means that projects which link to gtirb via cmake won't have to deal with
  # them.
  target_compile_options(${PROJECT_NAME} PUBLIC -wd4100) # unreferenced formal
                                                         # parameter
  target_compile_options(
    ${PROJECT_NAME} PUBLIC -wd4127
  ) # conditional expression is constant
  target_compile_options(
    ${PROJECT_NAME} PUBLIC -wd4244
  ) # conversion from 'type1' to 'type2', possible loss of data
  target_compile_definitions(
    ${PROJECT_NAME} PUBLIC
    _SILENCE_CXX17_ITERATOR_BASE_CLASS_DEPRECATION_WARNING
  )

  target_compile_options(
    ${PROJECT_NAME} PUBLIC -wd4251
  ) # 'identifier' : class 'type' needs to have dll- interface to be used by
    # clients of class 'type2'
  target_compile_options(${PROJECT_NAME} PUBLIC -wd4275) # Non-dll interface
                                                         # base classes.
endif()

if(UNIX
   AND NOT CYGWIN
   AND ("${CMAKE_BUILD_TYPE}" STREQUAL "RelWithDebInfo" OR "${CMAKE_BUILD_TYPE}"
                                                           STREQUAL "Debug")
   AND ${GTIRB_STRIP_DEBUG_SYMBOLS}
)
  string(
    RANDOM
    LENGTH 32
    ALPHABET "abcdef0123456789" BUILD_ID
  )
  string(SUBSTRING "${BUILD_ID}" 0 2 BUILD_ID_PREFIX)
  string(SUBSTRING "${BUILD_ID}" 2 32 BUILD_ID_SUFFIX)
  target_link_libraries(${PROJECT_NAME} PRIVATE "-Wl,--build-id=0x${BUILD_ID}")
  add_custom_command(
    TARGET ${PROJECT_NAME}
    POST_BUILD
    COMMAND objcopy --only-keep-debug $<TARGET_FILE:${PROJECT_NAME}>
            ${CMAKE_BINARY_DIR}/bin/${BUILD_ID_SUFFIX}.debug
    COMMAND objcopy --strip-debug $<TARGET_FILE:${PROJECT_NAME}>
  )
  install(
    FILES "${CMAKE_BINARY_DIR}/bin/${BUILD_ID_SUFFIX}.debug"
    COMPONENT debug-file
    DESTINATION "lib/debug/.build-id/${BUILD_ID_PREFIX}"
  )
endif()

if(CLANG_TIDY_EXE)
  set_target_properties(
    ${PROJECT_NAME} PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_EXE}"
  )
endif()

if(GTIRB_ENABLE_TESTS)
  add_subdirectory(test)
endif()

install(
  TARGETS ${PROJECT_NAME}
  COMPONENT library
  EXPORT gtirbTargets
  INCLUDES
  DESTINATION include
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)
install(
  FILES ${${PROJECT_NAME}_H}
  COMPONENT headers
  DESTINATION include/gtirb
)
install(
  DIRECTORY "${CMAKE_BINARY_DIR}/include/gtirb/proto"
  COMPONENT headers
  DESTINATION include/gtirb
)
install(
  FILES "${CMAKE_BINARY_DIR}/include/gtirb/version.h"
  COMPONENT headers
  DESTINATION include/gtirb
)

=== doc/cl/CMakeLists.txt ===
set(SDT_SCRIPT ${CMAKE_CURRENT_SOURCE_DIR}/write-documentation.lisp)
set(README ${CMAKE_SOURCE_DIR}/cl/README.md)
set(HTML_INDEX ${CMAKE_BINARY_DIR}/doc/html/cl/index.html)

file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/doc/html/cl")
file(GLOB CL_SOURCES ${CMAKE_SOURCE_DIR}/cl/*.lisp ${CMAKE_SOURCE_DIR}/cl/*.asd)

add_custom_command(
  OUTPUT ${HTML_INDEX}
  DEPENDS ${SDT_SCRIPT} ${README} ${CL_SOURCES}
  COMMAND
    ${LISP} --noinform --dynamic-space-size 16384 --no-userinit --no-sysinit
    --disable-debugger --load ${QUICKLISP}/setup.lisp --eval
    "(asdf:initialize-source-registry `(:source-registry (:tree \"${CMAKE_SOURCE_DIR}/cl\") :inherit-configuration))"
    --script ${SDT_SCRIPT} gtirb ${README} ${HTML_INDEX}
  VERBATIM
  COMMENT "Generating API documentation with SDT"
)
add_custom_target(sdt ALL DEPENDS ${HTML_INDEX})
add_dependencies(doc sdt)

=== doc/cpp/CMakeLists.txt ===
# based on sample in https://majewsky.wordpress.com/2010/08/14/tip-of-the-day-
# cmake-and-doxygen/ add a target to generate API documentation with Doxygen

cmake_minimum_required(VERSION 3.3)

find_package(Doxygen)
if(DOXYGEN_FOUND)

  set(ROOTDIR "${CMAKE_CURRENT_SOURCE_DIR}/../..")
  set(DOTDIR "${CMAKE_CURRENT_SOURCE_DIR}/../dot")

  set(BUILDFILES_IN ../preprocmd.py DoxygenLayout.xml)
  foreach(_inf ${BUILDFILES_IN})
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/${_inf} ${CMAKE_CURRENT_BINARY_DIR}/${_inf}
      @ONLY
    )
  endforeach()

  # Handle version initialization
  file(READ "${ROOTDIR}/version.txt" ver)

  string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
  set(GTIRB_MAJOR_VERSION ${CMAKE_MATCH_1})

  string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
  set(GTIRB_MINOR_VERSION ${CMAKE_MATCH_1})

  string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
  set(GTIRB_PATCH_VERSION ${CMAKE_MATCH_1})

  configure_file(
    "${ROOTDIR}/include/gtirb/version.h.in"
    "${ROOTDIR}/include/gtirb/version.h" @ONLY
  )

  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in"
    "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" @ONLY
  )

  # adapted from https://gist.github.com/abravalheri/11214134

  macro(move_filename file_list newdir)
    foreach(src_file ${${file_list}})
      get_filename_component(src_file_name "${src_file}" NAME)
      list(REMOVE_ITEM ${file_list} "${src_file}")
      list(APPEND ${file_list} "${newdir}/${src_file_name}")
    endforeach()
  endmacro()

  # ----------------------------------------------------------------------
  # copy dot files into a subdir of the working directory
  # ----------------------------------------------------------------------
  file(GLOB DOTFILES_IN "${DOTDIR}/*")

  set(DOTFILES ${DOTFILES_IN})
  move_filename(DOTFILES ${CMAKE_CURRENT_BINARY_DIR})

  # message("DOTFILES = ${DOTFILES}")

  add_custom_command(
    OUTPUT ${DOTFILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${DOTFILES_IN}
    COMMAND mkdir -p dot
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${DOTDIR} dot
    COMMENT "copying dot dir"
    VERBATIM
  )

  # ----------------------------------------------------------------------
  # copy md files into the working directory
  # ----------------------------------------------------------------------

  set(MDFILES_IN "${CMAKE_CURRENT_SOURCE_DIR}/README.md")

  set(MDFILES ${MDFILES_IN})
  move_filename(MDFILES ${CMAKE_CURRENT_BINARY_DIR})
  # message("MDFILES = ${MDFILES}")

  gtirb_find_python()

  foreach(_inmd ${MDFILES_IN})
    get_filename_component(_outmd "${_inmd}" NAME)
    add_custom_command(
      OUTPUT ${_outmd}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${_inmd}
      COMMAND ${CMAKE_COMMAND} -E copy ${_inmd} "${_outmd}.in"
      COMMAND ${PYTHON} ../preprocmd.py "${_outmd}.in" ${_outmd}
      COMMENT "processing ${_outmd}"
      VERBATIM
    )
  endforeach()

  # ----------------------------------------------------------------------
  # Main target
  # ----------------------------------------------------------------------

  add_custom_target(
    cpp_doxyout
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${DOTFILES}
    DEPENDS ${MDFILES}
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    COMMENT "Generating C++ API documentation with Doxygen"
    VERBATIM
  )

  add_dependencies(doc cpp_doxyout)
endif(DOXYGEN_FOUND)

=== doc/examples/CMakeLists.txt ===
if(CL_API)
  list(APPEND EXAMPLE_FILES_IN "${CMAKE_CURRENT_SOURCE_DIR}/cfg-paths.lisp"
              "${CMAKE_CURRENT_SOURCE_DIR}/data-symbols.lisp"
              "${CMAKE_CURRENT_SOURCE_DIR}/show-cfg.lisp"
  )
endif(CL_API)

if(CXX_API)
  include_directories("${CMAKE_SOURCE_DIR}/include")
  # Find protobuf generated headers in the build directory
  include_directories("${CMAKE_BINARY_DIR}/src/")
  # Find our version.h header file
  include_directories("${CMAKE_BINARY_DIR}/include")

  # Suppress warning from protobuf headers.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
    add_compile_options(-wd4100)
  endif()

  add_executable(ex-api-walkthrough api-walkthrough.cpp)
  target_link_libraries(ex-api-walkthrough gtirb)
  target_compile_definitions(
    ex-api-walkthrough PRIVATE GTIRB_WRAP_UTILS_IN_NAMESPACE
  )

  add_executable(ex-data-symbols data-symbols.cpp)
  target_link_libraries(ex-data-symbols gtirb)
  target_compile_definitions(
    ex-data-symbols PRIVATE GTIRB_WRAP_UTILS_IN_NAMESPACE
  )

  add_executable(ex-cfg-paths cfg-paths.cpp)
  target_link_libraries(ex-cfg-paths gtirb)
  target_compile_definitions(ex-cfg-paths PRIVATE GTIRB_WRAP_UTILS_IN_NAMESPACE)

  add_executable(ex-functions functions.cpp)
  target_link_libraries(ex-functions gtirb)
  target_compile_definitions(ex-functions PRIVATE GTIRB_WRAP_UTILS_IN_NAMESPACE)

  find_library(CAPSTONE NAMES capstone)
  if(CAPSTONE)
    add_executable(ex-jumps jumps.cpp)
    target_link_libraries(ex-jumps gtirb ${CAPSTONE})
    target_compile_definitions(ex-jumps PRIVATE GTIRB_WRAP_UTILS_IN_NAMESPACE)
  endif()

  list(
    APPEND EXAMPLE_FILES_IN
           "${CMAKE_CURRENT_SOURCE_DIR}/api-walkthrough.cpp"
           "${CMAKE_CURRENT_SOURCE_DIR}/cfg-paths.cpp"
           "${CMAKE_CURRENT_SOURCE_DIR}/data-symbols.cpp"
           "${CMAKE_CURRENT_SOURCE_DIR}/functions.cpp"
           "${CMAKE_CURRENT_SOURCE_DIR}/jumps.cpp"
  )
endif(CXX_API)

if(JAVA_API)
  list(APPEND EXAMPLE_FILES_IN "${CMAKE_CURRENT_SOURCE_DIR}/cfgpaths.java"
              "${CMAKE_CURRENT_SOURCE_DIR}/datasymbols.java"
  )
endif(JAVA_API)

if(PY_API)
  list(APPEND EXAMPLE_FILES_IN "${CMAKE_CURRENT_SOURCE_DIR}/cfg-paths.py"
              "${CMAKE_CURRENT_SOURCE_DIR}/data-symbols.py"
              "${CMAKE_CURRENT_SOURCE_DIR}/show-cfg.py"
  )
endif(PY_API)

macro(move_filename file_list newdir)
  foreach(src_file ${${file_list}})
    get_filename_component(src_file_name "${src_file}" NAME)
    list(REMOVE_ITEM ${file_list} "${src_file}")
    list(APPEND ${file_list} "${newdir}/${src_file_name}")
  endforeach()
endmacro()

set(EXAMPLE_FILES ${EXAMPLE_FILES_IN})
move_filename(EXAMPLE_FILES ${CMAKE_CURRENT_BINARY_DIR})

if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  foreach(_inmd ${EXAMPLE_FILES_IN})
    get_filename_component(_outmd "${_inmd}" NAME)
    add_custom_command(
      OUTPUT ${_outmd}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${_inmd}
      COMMAND ${CMAKE_COMMAND} -E copy ${_inmd} "${_outmd}"
      COMMENT "copying ${_outmd}"
      VERBATIM
    )
  endforeach()
endif()

add_custom_target(
  doc_examples
  DEPENDS ${EXAMPLE_FILES}
  COMMENT "copying examples to output"
  VERBATIM
)

add_dependencies(doc doc_examples)

=== doc/general/CMakeLists.txt ===
# based on sample in https://majewsky.wordpress.com/2010/08/14/tip-of-the-day-
# cmake-and-doxygen/ add a target to generate API documentation with Doxygen

cmake_minimum_required(VERSION 3.3)

find_package(Doxygen 1.8.11)
if(DOXYGEN_FOUND)

  set(DOC_INDIR "${CMAKE_CURRENT_SOURCE_DIR}/..")
  set(ROOTDIR "${CMAKE_CURRENT_SOURCE_DIR}/../..")

  set(BUILDFILES_IN ../preprocmd.py DoxygenLayout.xml)
  foreach(_inf ${BUILDFILES_IN})
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/${_inf} ${CMAKE_CURRENT_BINARY_DIR}/${_inf}
      @ONLY
    )
  endforeach()

  # Handle version initialization
  file(READ "${ROOTDIR}/version.txt" ver)

  string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
  set(GTIRB_MAJOR_VERSION ${CMAKE_MATCH_1})

  string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
  set(GTIRB_MINOR_VERSION ${CMAKE_MATCH_1})

  string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
  set(GTIRB_PATCH_VERSION ${CMAKE_MATCH_1})

  configure_file(
    "${ROOTDIR}/include/gtirb/version.h.in"
    "${ROOTDIR}/include/gtirb/version.h" @ONLY
  )

  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in"
    "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" @ONLY
  )

  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/examples.dox"
    "${CMAKE_CURRENT_BINARY_DIR}/examples.dox" @ONLY
  )

  # adapted from https://gist.github.com/abravalheri/11214134

  macro(move_filename file_list newdir)
    foreach(src_file ${${file_list}})
      get_filename_component(src_file_name "${src_file}" NAME)
      list(REMOVE_ITEM ${file_list} "${src_file}")
      list(APPEND ${file_list} "${newdir}/${src_file_name}")
    endforeach()
  endmacro()

  # ----------------------------------------------------------------------
  # copy dot files into a subdir of the working directory
  # ----------------------------------------------------------------------
  file(GLOB DOTFILES_IN "${DOC_INDIR}/dot/*")

  set(DOTFILES ${DOTFILES_IN})
  move_filename(DOTFILES ${CMAKE_CURRENT_BINARY_DIR})

  # message("DOTFILES = ${DOTFILES}")

  add_custom_command(
    OUTPUT ${DOTFILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${DOTFILES_IN}
    COMMAND mkdir -p dot
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${DOC_INDIR}/dot dot
    COMMENT "copying dot dir"
    VERBATIM
  )

  # ----------------------------------------------------------------------
  # copy md files into the working directory
  # ----------------------------------------------------------------------

  set(MDFILES_IN
      "${DOC_INDIR}/general/AuxDataContainer.md"
      "${DOC_INDIR}/general/Block.md"
      "${DOC_INDIR}/general/ByteBlock.md"
      "${DOC_INDIR}/general/ByteInterval.md"
      "${DOC_INDIR}/general/CFG.md"
      "${DOC_INDIR}/general/CfgEdge.md"
      "${DOC_INDIR}/general/CfgEdgeLabel.md"
      "${DOC_INDIR}/general/CfgNode.md"
      "${DOC_INDIR}/general/CodeBlock.md"
      "${DOC_INDIR}/general/COMPONENTS.md"
      "${DOC_INDIR}/general/DataBlock.md"
      "${DOC_INDIR}/general/IR.md"
      "${DOC_INDIR}/general/Module.md"
      "${DOC_INDIR}/general/Node.md"
      "${DOC_INDIR}/general/ProxyBlock.md"
      "${DOC_INDIR}/general/Section.md"
      "${DOC_INDIR}/general/Symbol.md"
      "${DOC_INDIR}/general/SymbolicExpression.md"
      "${DOC_INDIR}/general/SymAddrAddr.md"
      "${DOC_INDIR}/general/SymAddrConst.md"
      "${DOC_INDIR}/general/Version.md"
      "${DOC_INDIR}/binary-representation.md"
      "${DOC_INDIR}/CFG-Edges.md"
      "${ROOTDIR}/AuxData.md"
      "${ROOTDIR}/CONTRIBUTING.md"
      "${ROOTDIR}/FAQ.md"
      "${ROOTDIR}/PROTOBUF.md"
      "${ROOTDIR}/README.md"
      "${DOC_INDIR}/examples/stack-stamp.md"
  )
  set(MDFILES ${MDFILES_IN})
  move_filename(MDFILES ${CMAKE_CURRENT_BINARY_DIR})

  gtirb_find_python()
  foreach(_inmd ${MDFILES_IN})
    get_filename_component(_outmd "${_inmd}" NAME)
    add_custom_command(
      OUTPUT ${_outmd}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${_inmd} ../preprocmd.py
      COMMAND ${CMAKE_COMMAND} -E copy ${_inmd} "${_outmd}.in"
      COMMAND ${PYTHON} ../preprocmd.py "${_outmd}.in" ${_outmd}
      COMMENT "processing ${_outmd}"
      VERBATIM
    )
  endforeach()

  set(SVGFILES_IN "${ROOTDIR}/.gtirb.svg"
                  "${DOC_INDIR}/examples/.stack-stamp.svg"
  )
  set(SVGFILES ${SVGFILES_IN})
  move_filename(SVGFILES ${CMAKE_CURRENT_BINARY_DIR})

  foreach(_insvg ${SVGFILES_IN})
    get_filename_component(_outsvg "${_insvg}" NAME)
    add_custom_command(
      OUTPUT ${_outsvg}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${_insvg}
      COMMAND ${CMAKE_COMMAND} -E copy ${_insvg} "${_outsvg}"
      COMMENT "copying ${_outsvg}"
      VERBATIM
    )
  endforeach()

  # ----------------------------------------------------------------------
  # Main target
  # ----------------------------------------------------------------------

  add_custom_target(
    general_doxyout
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${MDFILES}
    DEPENDS ${SVGFILES}
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    COMMENT "Generating general API documentation with Doxygen"
    VERBATIM
  )

  add_dependencies(doc general_doxyout)

  if(CXX_API)
    add_dependencies(general_doxyout cpp_doxyout)
  endif()

endif(DOXYGEN_FOUND)

=== doc/java/CMakeLists.txt ===
if(GTIRB_JAVA_API)
  include(UseJava)

  # ---------------------------------------------------------------------------
  # Running javadoc requires all dependencies including jar files, so generate
  # the jar file names with complete paths. What follows is identical to what is
  # in the java/CMakeLists.txt, where the names are originally generated.
  # ---------------------------------------------------------------------------

  # Use only minor version, patch versions might not be available
  string(REGEX MATCH "([^\.]+)\.([^\.]+)\.([^\.]+)" PROTOBUF_VERSION_MATCH
               ${Protobuf_VERSION}
  )
  set(PROTOBUF_MAJOR_VERSION ${CMAKE_MATCH_1})
  set(PROTOBUF_MINOR_VERSION ${CMAKE_MATCH_2})
  set(JAVA_PROTOBUF_VERSION
      "${PROTOBUF_MAJOR_VERSION}.${PROTOBUF_MINOR_VERSION}.0"
  )

  # Full path to the two needed jar files
  set(PROTOBUF_JARFILE
      "${CMAKE_BINARY_DIR}/java/protobuf-java-${JAVA_PROTOBUF_VERSION}.jar"
  )
  set(GTIRB_API_JARFILE
      "${CMAKE_BINARY_DIR}/java/gtirb_api-${GTIRB_MAJOR_VERSION}.${GTIRB_MINOR_VERSION}.${GTIRB_PATCH_VERSION}.jar"
  )

  if(WIN32)
    set(CP_SEP "\;")
  else()
    set(CP_SEP ":")
  endif()

  set(JAR_FILE_LIST "${GTIRB_API_JARFILE}${CP_SEP}${PROTOBUF_JARFILE}")

  # Set the directory that generated HTML will go into
  set(JAVADOC_DIR "${CMAKE_BINARY_DIR}/doc/html/java")

  # The javadoc command line
  add_custom_target(
    javadoc
    DEPENDS gtirb-java-api
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${GTIRB_JAVA_APIDOCS_DIR}
            ${JAVADOC_DIR}
    VERBATIM
  )

  # With this, "make doc" will also run javadoc
  add_dependencies(doc javadoc)

else()
  message(
    WARNING
      "java is not enabled. HTML documentation for the Java API will not be generated."
  )
endif()

=== .ci/PKGBUILD ===
# Contributor: Eric Schulte <eschulte@grammatech.com>
# Maintainer: Eric Schulte <eschulte@grammatech.com>
_srcname=gtirb
pkgname=gtirb-git
pkgver=v1.4.7.r0.gb3094954
pkgrel=1
pkgdesc="GrammaTech Intermediate Representation for Binaries"
arch=('x86_64')
url="https://github.com/grammatech/gtirb"
license=('MIT')
depends=('protobuf' 'python-networkx')
makedepends=('git' 'cmake' 'python' 'doxygen' 'graphviz' 'boost')
provides=('gtirb')
source=('git://github.com/grammatech/gtirb.git')
sha512sums=('SKIP')

pkgver() {
  cd "$_srcname"
  git describe --long --tags --exclude "gt/*" | sed 's/\([^-]*-g\)/r\1/;s/[-:/ ]/./g'
}

build() {
    cd "$_srcname/"
    cmake . -Bbuild -DCMAKE_INSTALL_PREFIX=/usr -DGTIRB_CL_API=OFF \
      -DCMAKE_BUILD_TYPE=${BUILD_TYPE-RelWithDebInfo} \
      -DCMAKE_CXX_COMPILER=${COMPILER-g++}
    cmake --build build --target all doc
}

package() {
  cd "$_srcname/"
  make -Cbuild DESTDIR="$pkgdir" install
  mkdir -p "$pkgdir"/usr/share/doc/$_srcname
  cp -R build/doc/html/ "$pkgdir"/usr/share/doc/$_srcname
}
